package top.jerryyan.RN.A.VersionUpgrade;

import android.app.DownloadManager;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.net.Uri;
import android.os.Build;
import androidx.core.content.FileProvider;

import java.io.File;

public class DownLoadBroadcastReceiver extends BroadcastReceiver {
    @Override
    public void onReceive(Context context, Intent intent) {
        long currentDownloadId = intent.getLongExtra(DownloadManager.EXTRA_DOWNLOAD_ID, -1);
        SharedPreferences sPreferences = context.getSharedPreferences("jerry_rn_a_version_upgrade", 0);
        long refernece = sPreferences.getLong("downloadId", 0);
        if (currentDownloadId == refernece) {
            DownloadManager downloadManager = (DownloadManager) context.getSystemService(Context.DOWNLOAD_SERVICE);
            Intent install = new Intent(Intent.ACTION_VIEW);
            DownloadManager.Query queryById = new DownloadManager.Query();
            queryById.setFilterById(currentDownloadId);
            Cursor cursor = downloadManager.query(queryById);
            String fileUri = null;
            if(cursor.moveToFirst()){
                if(cursor.getInt(cursor.getColumnIndex(DownloadManager.COLUMN_STATUS)) == DownloadManager.STATUS_SUCCESSFUL){
                    fileUri = cursor.getString(cursor.getColumnIndex(DownloadManager.COLUMN_LOCAL_URI));
                }else{
                    downloadManager.remove(currentDownloadId);
                    cursor.close();
                    return;
                }
                cursor.close();
            }
            if(fileUri == null) return;
            Uri fileUri1 = Uri.parse(fileUri);
            File file = new File(fileUri1.getPath());
            if (Build.VERSION.SDK_INT >= 24) {
                Uri apkUri = FileProvider.getUriForFile(context, context.getPackageName().concat(".fileprovider"), file);
                install.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION);
                install.setDataAndType(apkUri, "application/vnd.android.package-archive");
            } else {
                install.setDataAndType(Uri.parse(fileUri), "application/vnd.android.package-archive");
            }
            install.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
            context.startActivity(install);
        }
    }
}
